#!/usr/bin/env python
#*****************************************************************************/
#*  LibreDWG - free implementation of the DWG file format                    */
#*                                                                           */
#*  Copyright (C) 2011 Free Software Foundation, Inc.                        */
#*  Copyright (C) 2011 Guruprasad Rane                                       */
#*                                                                           */
#*  This library is free software, licensed under the terms of the GNU       */
#*  General Public License as published by the Free Software Foundation,     */
#*  either version 3 of the License, or (at your option) any later version.  */
#*  You should have received a copy of the GNU General Public License        */
#*  along with this program.  If not, see <http://www.gnu.org/licenses/>.    */
#*****************************************************************************/
#
# comparexml.py Version 0.1 Date:6th November 2011
# created by Guruprasad Rane <raneguruprasad@gmail.com>
# Description: Compares two xml files. First one generate using # AutoCad>dwgtotxt.lisp>txttoxml.py>XML file.
# Second onne generated using LIbreDWG>Testsuite>XML file. Ecah property of every object gets compaired.
# Result is given in for of numeric score like "30 Sucess 5 Failure"
# Usage: In terminal type ./comparexml.py LispGenerateXML.xml testsuiteGeneratedXML.xml

from xml.etree import ElementTree as ET
import sys
import os

SucessCount=0
FailCount=0
XmlTSFilename=sys.argv[1]
XmlLDFilename=sys.argv[2]
FRTS=open(XmlTSFilename,'r')
FRLD=open(XmlLDFilename,'r')
XmlTSContent=FRTS.read()
XmlLDContent=FRLD.read()
TSelement = ET.XML(XmlTSContent)
LDelement = ET.XML(XmlLDContent)

def GetLDsubelement(intID):
	for LDsubelement in LDelement:
		if LDsubelement.get('id')==intID:
			return LDsubelement
			break

for TSsubelement in TSelement:
	TSsubelementID=TSsubelement.get('id')
	TSsubelementAttribs=TSsubelement.attrib
	LDsubelement=GetLDsubelement(TSsubelementID)
	if LDsubelement==None:
		FailCount=FailCount+1
		print "Entity with id='"+str(TSsubelementID)+"'\t\t\t\tErrNo: "+str(FailCount)+"\n\tNot Found"
	else:
		LDsubelementAttribs=LDsubelement.attrib	
		for k, v in TSsubelementAttribs.iteritems():
			if k in LDsubelementAttribs:
				if LDsubelementAttribs[k]==v:
					SucessCount=SucessCount+1
				else:
					FailCount=FailCount+1
					print "For id='"+TSsubelementAttribs['id']+"'\t\t\t\t\tErrNo: "+str(FailCount)+"\n\tNeeded\t"+k+"='"+v+"'\n\tFound \t"+k+"='"+LDsubelementAttribs[k]+"'"
			else:
				FailCount=FailCount+1
				print "For id='"+TSsubelementAttribs['id']+"'\t\t\t\t\tErrNo: "+str(FailCount)+"\n\tAttribute '"+k+"' not found"
print str(SucessCount)+" sucess " + str(FailCount) + " failure"
